#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#

from baselevel import *

red = Create_String(String, "red", (255, 0, 0))
red.Add_Sequence("001")

red = Create_Component(Light_Control, red)
clockA = Create_Component(Stimulator, "A", "011")
clockB = Create_Component(Stimulator, "B", "101")
andgate = Create_Component(And_Gate)
original = andgate.Get_Location()


Meta_Data(text = "It goes 'On' And 'On'",
    tick = 0.25,
    image = "tree1",
    desc = "For this level, arrange for the lights to flash in a "
        "different rhythm. The lights should only flash on when "
        "both inputs are On. To solve this level, "
        "use the new 'And' component. The output of 'And' is On when "
        "both inputs are On.\n\n"
        "Hint: Try reducing the speed of the flashing lights using the "
        "'Speed Control' on the right-hand side. "
        "If you reduce it to zero, you can step "
        "through all possible input conditions by pressing Step.",
    guide = [
    Guide(trigger = "True",
        point_at = "andgate",
        requires_ack = True,
        text = "This is the 'And' component. It has two inputs. The output "
            "is 'On' if both inputs are 'On'. If either input is 'Off', the "
            "'And' output is also Off. Click 'Next...' to continue."),
    Guide(trigger = "True",
        point_at = "None",
        text = "Connect each input of 'And' to one of the flashing inputs."),
    Guide(trigger = "((andgate in clockA.provides) "
                        "and (andgate in clockB.provides))",
        point_at = "None",
        text = "Notice that the output of 'And' is only On when both the "
            "inputs are On. Connect the output of 'And' to the lights to "
            "complete the level"),
    ])

