#
# Christmas Logic 
# Copyright (C) Jack Whitham 2009
#
# endgame
from baselevel import *

(R, G, B, Y) = Gen_Chewy(Create_String)

# The following sequence explains why Christmas light displays are
# not normally controlled by hand-optimised logic...
active = True
rt = bt = gt = yt = False
SEQUENCE = (("rgby" * 4) + ("ybgr" * 4) + "*fzfz" + ("rbgy" * 4) + 
            "fzfz" + ("bgyr" * 4) + "ffff*")
for ch in (SEQUENCE[ 2: ] + SEQUENCE[ :2 ]):
    if ch in "rf":
        R.Add_Sequence("1")
        rt = active
    elif rt:
        R.Add_Sequence("1")
        rt = False
    else:
        R.Add_Sequence("0")

    if ch in "gf":
        G.Add_Sequence("1")
        gt = active
    elif gt:
        G.Add_Sequence("1")
        gt = False
    else:
        G.Add_Sequence("0")

    if ch in "bf":
        B.Add_Sequence("1")
        bt = active
    elif bt:
        B.Add_Sequence("1")
        bt = False
    else:
        B.Add_Sequence("0")

    if ch in "yf":
        Y.Add_Sequence("1")
        yt = active
    elif yt:
        Y.Add_Sequence("1")
        yt = False
    else:
        Y.Add_Sequence("0")

    if ch == '*':
        active = not active

R = Create_Component(Light_Control, R)
G = Create_Component(Light_Control, G)
B = Create_Component(Light_Control, B)
Y = Create_Component(Light_Control, Y)

(x, y0) = G.Get_Location()
(x, y1) = B.Get_Location()
y = (y0 + y1) / 2
splash = Create_Component(End_Component,
            "Congratulations! You have completed the game!",
            [R, G, B, Y])
splash.Set_Location((100, y))


Meta_Data(text = "You Win!", desc = "Win", 
    unreal_level = True,
    dis_inputs = True, image = "i3u")

